unit hiGL_Depth;

interface

uses Kol,Share,Debug,OpenGL;

const
  glfArr:array[0..7] of cardinal = (GL_NEVER,GL_LESS,GL_EQUAL,GL_LEQUAL,GL_GREATER,GL_NOTEQUAL,GL_GEQUAL,GL_ALWAYS);
type
  THIGL_Depth = class(TDebug)
   private
    d:PData;
    dt,di: TData;
    r: Array [0..2] of  glfloat;
   public
    _prop_Func:integer;
    _prop_Mask:integer;
    _prop_RangeNear:real;
    _prop_RangeFar:real;
            
    _data_Func:THI_Event;
    _data_Mask:THI_Event;
    _data_RangeNear:THI_Event;
    _data_RangeFar:THI_Event;
    _event_onFunc:THI_Event;
    _event_onMask:THI_Event;
    _event_onRange:THI_Event;
        
    procedure _work_doFunc(var _Data:TData; Index:word);
    procedure _work_doMask(var _Data:TData; Index:word);
    procedure _work_doRange(var _Data:TData; Index:word);    
    procedure _var_GetFunc(var _Data:TData; Index:word);
    procedure _var_GetMask(var _Data:TData; Index:word);
    procedure _var_GetRange(var _Data:TData; Index:word);        
  end;

implementation

procedure THIGL_Depth._work_doFunc;
begin
    glDepthFunc(glfArr[ReadInteger(_Data,_data_Func,_prop_Func)]);
    _hi_CreateEvent(_Data,@_event_onFunc);
end;

procedure THIGL_Depth._work_doMask;
begin
    glDepthMask(ReadInteger(_Data,_data_Mask,_prop_Mask)<>0);
   _hi_CreateEvent(_Data,@_event_onMask);
end;

procedure THIGL_Depth._work_doRange;
begin
  glDepthRange(ReadReal(_data,_data_RangeNear,_prop_RangeNear), ReadReal(_data,_data_RangeFar,_prop_RangeFar));
   _hi_CreateEvent(_Data,@_event_onRange);
end;

procedure THIGL_Depth._var_GetFunc;
var f:glint; 
begin
    glGetIntegerv(GL_DEPTH_FUNC, @f);
   _Data := _DoData(f - 512);
end;

procedure THIGL_Depth._var_GetMask;
var m: boolean; 
begin
    glGetBooleanv(GL_DEPTH_WRITEMASK, @m);
    dtInteger(_Data,integer (m))
end;

procedure THIGL_Depth._var_GetRange;
var  i: integer;
begin
    dtNull(dt);
    dtNull(di);
    glGetFloatv(GL_DEPTH_Range, @r);
    for i := 0 to 2 do
     begin
      dtReal(di, r[i]);
      AddMTData(@dt, @di, d);
     end;
   _Data := dt;
   FreeData(d);    
end;
end.
