unit hiGL_Matrix;

interface

uses Windows,Kol,Share,Debug,OpenGL;

type
  THIGL_Matrix = class(TDebug)
   private
    matrix: Array[0..15] of GLFloat;
    d:PData;
    dt,di: TData;
   public
   _event_onPushMatrix:THI_Event;
   _event_onPopMatrix:THI_Event;
   _event_onLoadMatrix:THI_Event;
   _event_onMultMatrix:THI_Event;
   _data_Data:THI_Event;
     
    procedure _work_doPushMatrix(var _Data:TData; Index:word);
    procedure _work_doPopMatrix(var _Data:TData; Index:word);
    procedure _work_doMultMatrix(var _Data:TData; Index:word);
    procedure _work_doLoadMatrix(var _Data:TData; Index:word);
    procedure _var_Value(var _Data:TData; Index:word);

  end;

implementation

procedure THIGL_Matrix._work_doPushMatrix;
begin
   glPushMatrix;
   _hi_CreateEvent(_Data,@_event_onPushMatrix);
end;

procedure THIGL_Matrix._work_doPopMatrix;
begin
   glPopMatrix;
   _hi_CreateEvent(_Data,@_event_onPopMatrix);
end;

procedure THIGL_Matrix._work_doLoadMatrix;
var i: integer;
begin
  FreeData(@di);
  di := ReadMTData(_data,_data_Data);
  CopyData(@di,@di);
       d := @di;  
   for i := 0 to 15 do
    begin
     dtData(dt, d^);
     d := d.ldata; 
     matrix[i] := toReal(dt);
    end;
     glLoadMatrixf(@matrix);
    _hi_onEvent(_event_onLoadMatrix);
end;

procedure THIGL_Matrix._work_doMultMatrix;
var i: integer;
begin
  FreeData(@di);
  di := ReadMTData(_data,_data_Data);
  CopyData(@di,@di);
       d := @di;  
   for i := 0 to 15 do
    begin
     dtData(dt, d^);
     d := d.ldata; 
     matrix[i] := toReal(dt);
    end;
     glMultMatrixf(@matrix);
    _hi_onEvent(_event_onMultMatrix);
end;

procedure THIGL_Matrix._var_Value;
var i: integer;
begin
  dtNull(dt);
  dtNull(di);
   glGetFloatv (GL_MODELVIEW_MATRIX,@matrix);
   for i := 0 to 16 do
   begin
     dtReal(di, matrix[i]);
     AddMTData(@dt, @di, d);
   end;
   _Data := dt;
   FreeData(d);
end;

end.
