unit hiGl_Text2D;

interface

uses Windows,Kol,Share,Debug,OpenGL;

type
  THIGl_Text2D = class(TDebug)
   private
   public
    _prop_Font:TFontRec;
    _prop_Text:string;
    _prop_ListStart:integer;
    _prop_X:real;
    _prop_Y:real;
    _prop_Z:real;

    _event_onDraw:THI_Event;
    _event_onInit:THI_Event;
    _data_Text:THI_Event;
    _data_X:THI_Event;
    _data_Y:THI_Event;
    _data_Z:THI_Event;
    _data_GLHandle:THI_Event;

    procedure _work_doInit(var _Data:TData; Index:word);
    procedure _work_doDraw(var _Data:TData; Index:word);
    procedure _work_doDelete(var _Data:TData; Index:word);
  end;

implementation

procedure THIGl_Text2D._work_doInit;
var  hFontNew, hOldFont : HFONT;
     lf : TLOGFONT;
     DC:HDC;
begin
    DC := ReadInteger(_Data,_data_GLHandle,0);  
   { FillChar(lf, SizeOf(lf), 0);
    lf.lfHeight               :=   _prop_Font.Size;
    //lf.lfWeight               :=   _prop_Font.Size; //FW_NORMAL;
    lf.lfCharSet              :=   RUSSIAN_CHARSET; //ANSI_CHARSET;
    lf.lfOutPrecision         :=   OUT_DEFAULT_PRECIS ;
    lf.lfClipPrecision        :=   CLIP_DEFAULT_PRECIS ;
    lf.lfQuality              :=   DEFAULT_QUALITY ;
    lf.lfPitchAndFamily       :=   FF_DONTCARE OR DEFAULT_PITCH;
    lstrcpy(lf.lfFaceName,PChar(_prop_Font.Name));
    //lstrcpy (lf.lfFaceName, 'Arial Cyr');}
     hFontNew := CreateFont(_prop_Font.Size,        //  
                         0,        //  
                         0,        //  
                         0,        //  
                         FW_BOLD,      //  
                         0,        // 
                         0,        // 
                         0,        // 
                         RUSSIAN_CHARSET,      //   
                         OUT_TT_PRECIS,      //  
                         CLIP_DEFAULT_PRECIS,    //  
                         ANTIALIASED_QUALITY,    //  
                         FF_DONTCARE or DEFAULT_PITCH,  //   
                         PChar(_prop_Font.Name));
                         
    wglUseFontBitmaps(DC, 0, 256, _prop_ListStart);
    //hFontNew := CreateFontIndirect(lf);
    hOldFont := SelectObject(DC,hFontNew);
   // glColor(_prop_Font.Color);

    wglUseFontBitmaps(DC, 0, 256, _prop_ListStart);
     
    DeleteObject(SelectObject(DC,hOldFont));
    DeleteObject(SelectObject(DC,hFontNew));

    _hi_CreateEvent(_Data,@_event_onInit);
end;

procedure THIGl_Text2D._work_doDraw;
var Litera:String;
begin
  glPushAttrib(GL_ALL_ATTRIB_BITS);
   //glNormal3f(-1.0,-1.0,-1.0);
   //glColor(_prop_Font.Color);
   Litera := PAnsiChar(readstring(_data,_data_Text,_prop_Text));
   glListBase(_prop_ListStart);
   //glCallLists(Length (Litera), GL_UNSIGNED_BYTE, Litera);


   glRasterPos3f(ReadReal(_data,_data_X,_prop_X) ,
                 ReadReal(_data,_data_Y,_prop_Y) ,
                 ReadReal(_data,_data_Z,_prop_Z ));
   glCallLists( length( Litera ), GL_UNSIGNED_BYTE, PAnsiChar(Litera) );


   //glListBase(0);
  glPopAttrib;
  _hi_CreateEvent(_Data,@_event_onDraw);
end;

procedure THIGl_Text2D._work_doDelete;
begin
  glDeleteLists(_prop_ListStart, 256);
end;

end.
